
#Conditionally import wlstModule only when script is executed with jython
if __name__ == '__main__': 
    from wlstModule import *#@UnusedWildImport


######################################################################################
# ELJMSCacheCoordination - WLST Script For Cleaning Up The WebLogic Server Domain    #
#                                                                                    #
# Author: Reinhard Girstenbrei, Oracle Corporation                                   #
#                                                                                    #
# Configuration in: weblogic.properties                                              #
#                                                                                    #
######################################################################################


def loadProperties():
    propertiesInputStream = java.io.FileInputStream("weblogic.properties")
    properties = java.util.Properties()      
    properties.load(propertiesInputStream)
    propertiesInputStream = java.io.FileInputStream("project.properties")
    properties.load(propertiesInputStream)
    return properties





 
def removeGridLinkDatasource(datasourceName):
    try:
        print "Destroying Generic Datasource \"" + datasourceName + "\""
        cmo.destroyJDBCSystemResource(getMBean('/SystemResources/' + datasourceName))
    except Exception, e:
        print e
        print "Error: Generic Datasource \"" + datasourceName + "\" does not exist"
    print ""
    
def removeManagedServer(serverName):
    try:
        print "Destroying Managed Server \"" + serverName + "\""
        cd('/Servers/' + serverName)
        cmo.setMachine(None)
        editService.getConfigurationManager().removeReferencesToBean(getMBean('/Servers/' + serverName))
        cd('/')
        cmo.destroyServer(getMBean('/Servers/' + serverName))
    except Exception, e:
        print "Error: Managed Server \"" + serverName + "\" does not exist"
    print ""

def removeMachine(machineName):    
    try:    
        print "Destroying \"" + machineName + "\""
        editService.getConfigurationManager().removeReferencesToBean(getMBean('/Machines/' + machineName))
        cmo.destroyMachine(getMBean('/Machines/' + machineName))
    except Exception, e:
        print "Error: Machine \"" + machineName + "\" does not exist"
    print ""
	
def shutdownManagedServer(managedServerName):
    try:
        print "Shutting down \"" + managedServerName + "\""
        shutdown(name=managedServerName, entityType='Server', ignoreSessions='true', timeOut=1000, force='true')
    except Exception, e:
        print "Error: Shutdown of \"" + managedServerName + "\" failed"
    print ""
		
    
    

# =========== Main ===============
redirect(System.getProperty('user.dir') + '/teardown_wlst.log')
print "*************************************************************"
print "*** Removing a Cluster With Two Nodes On The Same Machine ***"
print "*************************************************************"
print

properties = loadProperties()

# Connect - interactive

#connect()

# Connect - hard coded

connect(
   properties.get('weblogic.admin.username'), 
   properties.get('weblogic.admin.password'), 
   properties.get('weblogic.admin.url'))


shutdownManagedServer(
   properties.get('weblogic.managed.server1'))
   
edit()
startEdit()

   
removeGridLinkDatasource(
   properties.get('weblogic.datasource'))
removeGridLinkDatasource(
   properties.get('weblogic.datasource.nonjta'))
removeManagedServer(
   properties.get('weblogic.managed.server1'))
removeMachine(
   properties.get('weblogic.machine'))


print ""   
save()
activate(block="true")
stopRedirect()
disconnect()
print""
print "*************************************************************"
print "Script finished."
print "*************************************************************"
