CREATE USER DBUSER IDENTIFIED BY DBUSER
/
GRANT RESOURCE TO DBUSER
/

CREATE TABLE DBUSER.PROXYTEST
(	
	"ID" NUMBER(*,0) NOT NULL ENABLE, 
	"VALUE" NUMBER(*,0), 
	CONSTRAINT PROXYTEST_PK PRIMARY KEY ("ID")
)
/

INSERT INTO DBUSER.PROXYTEST (ID, VALUE) VALUES (1, 1)
/
COMMIT
/

CREATE USER WEBUSER IDENTIFIED BY webuser
/
GRANT CONNECT TO WEBUSER
/

CREATE USER PROXYDUMMY identified by test
/
alter user PROXYDUMMY grant connect through webuser
/
GRANT create session to PROXYDUMMY
/

CREATE USER PROXYUSER IDENTIFIED BY test
/
alter user PROXYUSER grant connect through webuser
/
grant create session to PROXYUSER
/
grant select on DBUSER.PROXYTEST to PROXYUSER
/

CREATE USER PROXYWRITE IDENTIFIED BY test
/
alter user PROXYWRITE grant connect through webuser
/
grant create session to PROXYWRITE
/
grant select, insert, update on DBUSER.PROXYTEST to PROXYWRITE
/

begin

DBMS_FGA.ADD_POLICY (
   object_schema      =>  'DBUSER', 
   object_name        =>  'PROXYTEST', 
   policy_name        => 'AUDIT_POL_TEST_ENTITIES',
   audit_condition    =>  NULL,
   audit_column       =>  NULL,
   handler_schema     =>  NULL,
   handler_module     =>  NULL,
   enable             =>  TRUE,
   statement_types    => 'INSERT, UPDATE, SELECT, DELETE',
   audit_trail        =>  DBMS_FGA.DB + DBMS_FGA.EXTENDED);
end;
/
