package oracle.support.web;

import java.lang.management.ManagementFactory;

import javax.ejb.TransactionRolledbackLocalException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import oracle.support.model.TestFacadeLocal;
import oracle.support.security.UserToken;

public class BackingBean {
	private HttpServletRequest request = null;
	
    public void setRequest(HttpServletRequest request) {
    	this.request = request;
    }
    
	public String getNodeInfo() {
		return ManagementFactory.getRuntimeMXBean().getName();
	}

	public String readValue() {
		Context ctx = null;
		try {
			ctx = new InitialContext();
			TestFacadeLocal testFacade = (TestFacadeLocal) ctx
					.lookup("java:comp/env/MyTestFacade");
			return testFacade.readValue((UserToken) request.getSession().getAttribute("userToken"));
		} catch (NamingException ex) {
			ex.printStackTrace();
		}
		return "no bean";
	}

	public String incrementAndReadValue() throws ServletException {
		Context ctx = null;
		try {
			ctx = new InitialContext();
			TestFacadeLocal testFacade = (TestFacadeLocal) ctx
					.lookup("java:comp/env/MyTestFacade");
			return testFacade.incrementAndReadValue((UserToken) request.getSession().getAttribute("userToken"));
		} catch (NamingException ex) {
			ex.printStackTrace();
		} catch (TransactionRolledbackLocalException ex) {
			throw new ServletException("Action not authorized", ex);			
		}
		
		return "no bean";
	}

}
